#!/bin/bash
#
# This file was automatically generated by s2e-env at 2019-01-25 12:50:49.815180
#
# This script can be used to run the S2E analysis. Additional QEMU command line
# arguments can be passed to this script at run time
#

ENV_DIR="/data/tools/s2e/environment"
INSTALL_DIR="$ENV_DIR/install"
BUILD_DIR="$ENV_DIR/build/s2e"
BUILD=debug

# Comment this out to enable QEMU GUI
GRAPHICS=-nographic

if [ "x$1" = "xdebug" ]; then
  DEBUG=1
  shift
fi

DRIVE="-drive file=$ENV_DIR/images/cgc_debian-9.2.1-i386/image.raw.s2e,format=s2e,cache=writeback"

export S2E_CONFIG=s2e-config.lua
export S2E_SHARED_DIR=$INSTALL_DIR/share/libs2e
export S2E_MAX_PROCESSES=1
export S2E_UNBUFFERED_STREAM=1

if [ $S2E_MAX_PROCESSES -gt 1 ]; then
    # Multi-threaded mode does not support graphics output, so we override
    # whatever settings were there before.
    export GRAPHICS=-nographic
fi

if [ "x$DEBUG" != "x" ]; then

if [ ! -d "$BUILD_DIR/qemu-$BUILD" ]; then
    echo "No debug build found in $BUILD_DIR/qemu-$BUILD. Please run \`\`s2e build -g\`\`"
    exit 1
fi

QEMU="$BUILD_DIR/qemu-$BUILD/i386-softmmu/qemu-system-i386"
LIBS2E="$BUILD_DIR/libs2e-$BUILD/i386-s2e-softmmu/libs2e.so"

cat >> gdb.ini <<EOF
handle SIGUSR2 noprint
set disassembly-flavor intel
set print pretty on
set environment S2E_CONFIG=$S2E_CONFIG
set environment S2E_SHARED_DIR=$S2E_SHARED_DIR
set environment LD_PRELOAD=$LIBS2E
set environment S2E_UNBUFFERED_STREAM=1
#set environment QEMU_LOG_LEVEL=int,exec
#set environment S2E_QMP_SERVER=127.0.0.1:3322
EOF

GDB="gdb  --init-command=gdb.ini --args"

$GDB $QEMU $DRIVE \
    -k en-us $GRAPHICS -monitor null -m 256M -enable-kvm \
    -serial file:serial.txt -net none -net nic,model=e1000  \
    -loadvm ready $*

else

QEMU="$INSTALL_DIR/bin/qemu-system-i386"
LIBS2E="$INSTALL_DIR/share/libs2e/libs2e-i386-s2e.so"

LD_PRELOAD=$LIBS2E $QEMU $DRIVE \
    -k en-us $GRAPHICS -monitor null -m 256M -enable-kvm \
    -serial file:serial.txt -net none -net nic,model=e1000  \
    -loadvm ready $*

fi